*****************
function CC_CHECK
*****************
PARAMETERS pcSTRING

*-- PLEASE NOTE:
*-- m.cc_nbr AND m.cc_company are screen variables.
*-- This routine is called as a VALID routine in a 2.6
*-- screen. Example: VALID CC_CHECK(m.cc_nbr)

*-- This section is to keep the screen 'CLEAN' when the 
*-- transaction is edited and payment is changed to be 
*-- made by check or cash after initially being saved
*-- as a credit card transaction. If this is not done, the
*-- fields holding expiration date, card holder, credit card
*-- company and authorization # will still contain the old data.
****************************************************************
*-- No need to check if payment is NOT by Credit Card...
*IF UPPER(m.method) <> 'CREDITCARD'
*	IF !( EMPTY(m.CC_expire) OR EMPTY(Card_Hldr) or;
*		EMPTY(CC_Company) OR EMPTY(Auth_nbr) )
*		m.CC_expire = SPACE(5)
*		m.Card_hldr = SPACE(LEN(Booking.Card_hldr))
*		m.CC_Company= SPACE(LEN(Booking.CC_Company))
*		m.Auth_nbr	= SPACE(LEN(Booking.Auth_nbr))
*		SHOW GETS ONLY
*	ENDIF	
*	RETURN .T.
*ENDIF
****************************************************************

*-- The rest is generic except for the references to the above
*-- mentioned screen variables, m.cc_nbr and m.cc_company. 

*-- Otherwise, let's make sure we have a valid Credit Card #...	
PRIVATE jnI, jnMOD10, jnPOS, jnDIGIT, jcREMOVE, jlLEFT, jcCHAR
*-- Remove the non-alphanumeric characters.
*-- This list can be expanded by adding characters to jcREMOVE
jcREMOVE = ' -./'
FOR jnI = 1 TO LEN(jcREMOVE)
	pcSTRING = STRTRAN(pcSTRING, SUBSTR(jcREMOVE, jnI, 1), '')
ENDFOR
pcSTRING = ALLTRIM(pcSTRING)
jnMOD10 = 0
jlLEFT = IIF( LEN(pcSTRING) % 2 > 0, .T., .F.)
FOR jnPOS = 1 TO LEN(pcSTRING)
	IF jlLEFT
		jnDIGIT = jnPOS
	ELSE
		jnDIGIT = LEN(pcSTRING) - jnPOS + 1
	ENDIF
	jcCHAR = SUBSTR(pcSTRING, jnDIGIT, 1)
	IF ISDIGIT(jcCHAR)
		jnDIGIT = VAL(jcCHAR)
	ELSE
		jnDIGIT = AT(jcCHAR, ;
			'ABCDEFGHIJKLMNOPQRSTUVWXYZ..../') % 16
	ENDIF
	*-- Multiply by 2 if it is an *EVEN* digit.
	jnDIGIT = jnDIGIT * IIF(jnPOS % 2 = 0, 2, 1)				 	
	*-- If the result is larger than 10, the two digits
	*-- have to be added. This is accomplished by adding 
	*-- the INTEGER of the Current Digit divided by 10 
	*-- to the Current Digit divided by 10.
	jnDIGIT = INT(jnDIGIT / 10) + jnDIGIT % 10
	*-- If the result is 10 (occurs when jnDIGIT is odd)
	*-- add the 2 didits together again (becomes 1).
	jnDIGIT = IIF(jnDIGIT = 10, 1, jnDIGIT)
	*-- Sum all the digits
	jnMOD10 = jnMOD10 + jnDIGIT
ENDFOR
*-- Subtract the MOD 10 from 10.
jnMOD10 = 10 - MOD( jnMOD10, 10 )

*-- If we have a valid #, format it and find out the 
*-- credit card company being used.
IF STR(IIF(jnMOD10 = 10, 0, jnMOD10), 1) = '0'
	DO CC_COMP with pcSTRING
	SHOW OBJECT OBJNUM(m.cc_nbr)
	SHOW OBJECT OBJNUM(m.cc_company)
ENDIF
jnRETVAL = IIF(jnMOD10 = 10, 0, jnMOD10)

RETURN IIF( jnRETVAL = 0, .T., .F. )

*****************
PROCEDURE CC_COMP
*****************
PARAMETERS plcSTRING

PRIVATE jnRANGE, jnLENGTH
*-- We only need to check the 1st 8 digits to determine company. 
jnRANGE = VAL(SUBSTR(plcSTRING,1,8))
jnLENGTH = LEN(plcSTRING)
DO CASE 
CASE jnLENGTH = 13 AND BETWEEN(jnRANGE,40000000,49999999)
	m.cc_company = 'VISA'
CASE jnLENGTH = 14 AND BETWEEN(jnRANGE,30000000,30999999) OR;
	BETWEEN(jnRANGE,36000000,36999999) OR BETWEEN(jnRANGE,38000000,38999999)
	m.cc_company = 'DINERS CLUB'
CASE jnLENGTH = 15 AND BETWEEN(jnRANGE,20140000,20149999) OR;
	BETWEEN(jnRANGE,21490000,21499999) OR BETWEEN(jnRANGE,39000000,39009999)
	m.cc_company = 'DINERS CLUB'
CASE jnLENGTH = 15 AND BETWEEN(jnRANGE,34000000,34999999) OR;
	BETWEEN(jnRANGE,37000000,37999999)
	m.cc_company = 'AMERICAN EXPRESS'
CASE jnLENGTH = 16 AND BETWEEN(jnRANGE,30880000,30949999) OR;
	BETWEEN(jnRANGE,30960000,31029999) OR BETWEEN(jnRANGE,31120000,31209999) OR;
	BETWEEN(jnRANGE,31580000,31599999) OR BETWEEN(jnRANGE,33370000,33499999) OR;
	BETWEEN(jnRANGE,35280000,35899999)
	m.cc_company = 'JCB'
CASE jnLENGTH = 16 AND BETWEEN(jnRANGE,40000000,49999999)
	m.cc_company = 'VISA'
CASE jnLENGTH = 16 AND BETWEEN(jnRANGE,51000000,55999999)
	m.cc_company = 'MasterCard'
CASE jnLENGTH = 16 AND BETWEEN(jnRANGE,60110000,60110999) OR ;
	BETWEEN(jnRANGE,60112000,60119899)
	m.cc_company = 'DISCOVER'	
OTHERWISE
	m.cc_company = 'UNKNOWN'
ENDCASE

*-- Now, lets format the number based on its unformatted length.
DO CASE
CASE jnLENGTH = 13
	m.cc_nbr = SUBSTR(plcSTRING,1,4)+'-'+SUBSTR(plcSTRING,5,3)+'-'+;
				SUBSTR(plcSTRING,8,3)+'-'+SUBSTR(plcSTRING,11,3)
CASE jnLENGTH = 14
	m.cc_nbr = SUBSTR(plcSTRING,1,4)+'-'+SUBSTR(plcSTRING,5,6)+'-'+;
				SUBSTR(plcSTRING,11,4)
CASE jnLENGTH = 15
	m.cc_nbr = SUBSTR(plcSTRING,1,4)+'-'+SUBSTR(plcSTRING,5,6)+'-'+;
				SUBSTR(plcSTRING,11,5)
CASE jnLENGTH = 16
	m.cc_nbr = SUBSTR(plcSTRING,1,4)+'-'+SUBSTR(plcSTRING,5,4)+'-'+;
				SUBSTR(plcSTRING,9,4)+'-'+SUBSTR(plcSTRING,13,4)	
ENDCASE

RETURN
